package simulation;

public class EventList {
	private Event head, tail;

	EventList() {
		head = new Event();
		tail = new Event();
		head.next = tail;
	}

	public void InsertEvent(int type, double TimeOfEvent) {
		Event temp, pretemp;

		pretemp = this.head;
		temp = this.head.next;

		Event newEvent = new Event(type, TimeOfEvent);

		// Find the right place in the list using a sliding window
		while ((temp.eventTime < newEvent.eventTime) && (temp != tail)) {
			pretemp = temp;
			temp = temp.next;
		}

		pretemp.next = newEvent;
		newEvent.next = temp;
	}

	public Event FetchEvent() {
		Event temp = head.next;
		head.next = temp.next;
		temp.next = null;
		return temp;
	}

	public Event popFront() {
		Event temp = head.next;
		head.next = temp.next;
		temp.next = null;
		return temp;
	}
}
